<?php
/*
 * Copyright (c) 2013, webvariants GbR, http://www.webvariants.de
 *
 * This file is released under the terms of the MIT license. You can find the
 * complete text in the attached LICENSE file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

/**
 * Datentyp "Mehrzeiliger Text"
 *
 * Dieser Datentyp kann bis zu 65k Zeichen lange mehrzeilige Strings als Werte
 * annehmen. Die Minimal- und Maximallänge kann dabei beschränkt werden.
 */
class _WV_Datatype_StringText extends _WV_Datatype_Base_String implements WV_IDatatype {
	public function renderForm(sly_Form $form, WV_IProperty $property, $value) {
		$value  = $this->decodeFormValue($property, $value);
		$params = $property->getParams();

		extract($this->deserializeParams($params));

		$input = new sly_Form_Textarea('property_'.$property->getID().'_value', $property->getTitle(), $value);
		$input->addClass('property_errorable');
		$input->setMultilingual($property->isMultilingual());
		$input->setAttribute('style', $css);

		WV_Datatype::setHelpTextOnElement($form, $input, $property);
		$form->add($input);
		return $form;
	}
}
